Index: issm/trunk/src/c/classes/objects/Loads/Load.h
===================================================================
--- issm/trunk/src/c/classes/objects/Loads/Load.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Loads/Load.h	(revision 13975)
@@ -4,5 +4,4 @@
  * It is derived from Load, so DataSets can contain them.
  */ 
-
 
 #ifndef _LOAD_H_
@@ -25,7 +24,8 @@
 
 		virtual       ~Load(){};
-		
-		/*Virtual functions: {{{*/
 		virtual void  Configure(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters)=0;
+		virtual bool  IsPenalty(void)=0;
+		virtual int   GetNumberOfNodes(void)=0;
+		virtual void  GetNodesSidList(int* sidlist)=0;
 		virtual void  SetCurrentConfiguration(Elements* elements,Loads* loads,Nodes* nodes,Vertices* vertices,Materials* materials,Parameters* parameters)=0;
 		virtual void  CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs)=0;
@@ -36,5 +36,5 @@
 		virtual void  PenaltyCreatePVector(Vector<IssmDouble>* pf, IssmDouble kmax)=0;
 		virtual bool  InAnalysis(int analysis_type)=0;
-		/*}}}*/
+		virtual void  SetwiseNodeConnectivity(int* d_nz,int* o_nz,Node* node,bool* flags,int set1_enum,int set2_enum)=0;
 };
 #endif
Index: issm/trunk/src/c/classes/objects/Loads/Numericalflux.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Loads/Numericalflux.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Loads/Numericalflux.cpp	(revision 13975)
@@ -34,5 +34,5 @@
 }
 /*}}}*/
-/*}}}*//*FUNCTION Numericalflux::Numericalflux(int id, int i, IoModel* iomodel, int analysis_type) {{{*/
+/*FUNCTION Numericalflux::Numericalflux(int id, int i, IoModel* iomodel, int analysis_type) {{{*/
 Numericalflux::Numericalflux(int numericalflux_id,int i, IoModel* iomodel, int in_analysis_type){
 
@@ -175,5 +175,5 @@
 	_printLine_("   inputs");
 	inputs->DeepEcho();
-	
+
 }		
 /*}}}*/
@@ -183,10 +183,4 @@
 }
 /*}}}*/
-/*FUNCTION Numericalflux::MyRank {{{*/
-int    Numericalflux::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION Numericalflux::ObjectEnum{{{*/
 int Numericalflux::ObjectEnum(void){
@@ -198,5 +192,5 @@
 /*FUNCTION Numericalflux::copy {{{*/
 Object* Numericalflux::copy() {
-	
+
 	Numericalflux* numericalflux=NULL;
 
@@ -311,4 +305,46 @@
 }
 /*}}}*/
+/*FUNCTION Numericalflux::GetNodesSidList{{{*/
+void Numericalflux::GetNodesSidList(int* sidlist){
+
+	int type;
+	inputs->GetInputValue(&type,TypeEnum);
+	_assert_(sidlist);
+	_assert_(nodes);
+
+	switch(type){
+		case InternalEnum:
+			for(int i=0;i<NUMVERTICES_INTERNAL;i++) sidlist[i]=nodes[i]->Sid();
+			return;
+		case BoundaryEnum:
+			for(int i=0;i<NUMVERTICES_BOUNDARY;i++) sidlist[i]=nodes[i]->Sid();
+			return;
+		default:
+			_error_("Numericalflux type " << EnumToStringx(type) << " not supported yet");
+	}
+}
+/*}}}*/
+/*FUNCTION Numericalflux::GetNumberOfNodes{{{*/
+int Numericalflux::GetNumberOfNodes(void){
+
+	int type;
+	inputs->GetInputValue(&type,TypeEnum);
+
+	switch(type){
+		case InternalEnum:
+			return NUMVERTICES_INTERNAL;
+		case BoundaryEnum:
+			return NUMVERTICES_BOUNDARY;
+		default:
+			_error_("Numericalflux type " << EnumToStringx(type) << " not supported yet");
+	}
+
+}
+/*}}}*/
+/*FUNCTION Numericalflux::IsPenalty{{{*/
+bool Numericalflux::IsPenalty(void){
+	return false;
+}
+/*}}}*/
 /*FUNCTION Numericalflux::PenaltyCreateKMatrix {{{*/
 void  Numericalflux::PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs,IssmDouble kmax){
@@ -331,4 +367,55 @@
 	if (in_analysis_type==this->analysis_type) return true;
 	else return false;
+}
+/*}}}*/
+/*FUNCTION Numericalflux::SetwiseNodeConnectivity{{{*/
+void Numericalflux::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int set1_enum,int set2_enum){
+
+	/*Output */
+	int d_nz = 0;
+	int o_nz = 0;
+
+	/*Loop over all nodes*/
+	for(int i=0;i<this->GetNumberOfNodes();i++){
+
+		if(!flags[this->nodes[i]->Sid()]){
+
+			/*flag current node so that no other element processes it*/
+			flags[this->nodes[i]->Sid()]=true;
+
+			/*if node is clone, we have an off-diagonal non-zero, else it is a diagonal non-zero*/
+			switch(set2_enum){
+				case FsetEnum:
+					if(nodes[i]->indexing.fsize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				case GsetEnum:
+					if(nodes[i]->indexing.gsize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				case SsetEnum:
+					if(nodes[i]->indexing.ssize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				default: _error_("not supported");
+			}
+		}
+	}
+
+	/*Assign output pointers: */
+	*pd_nz=d_nz;
+	*po_nz=o_nz;
 }
 /*}}}*/
@@ -410,5 +497,5 @@
 		for(i=0;i<numdof;i++) for(j=0;j<numdof;j++) Ke->values[i*numdof+j]+=Ke_g2[i][j];
 	}
-	
+
 	/*Clean up and return*/
 	delete gauss;
@@ -702,5 +789,5 @@
 
 	/* Intermediaries*/
-	int        i,j,ig,index1,index2;
+	int        i,ig,index1,index2;
 	IssmDouble     DL,Jdet,dt,vx,vy,mean_vx,mean_vy,UdotN,thickness;
 	IssmDouble     xyz_list[NUMVERTICES_BOUNDARY][3];
@@ -796,9 +883,9 @@
 
 	/* Intermediaries*/
-	int        i,j,ig,index1,index2;
-	IssmDouble     DL,Jdet,vx,vy,mean_vx,mean_vy,UdotN,thickness;
-	IssmDouble     xyz_list[NUMVERTICES_BOUNDARY][3];
-	IssmDouble     normal[2];
-	IssmDouble     L[numdof];
+	int        i,ig,index1,index2;
+	IssmDouble DL,Jdet,vx,vy,mean_vx,mean_vy,UdotN,thickness;
+	IssmDouble xyz_list[NUMVERTICES_BOUNDARY][3];
+	IssmDouble normal[2];
+	IssmDouble L[numdof];
 	GaussTria *gauss;
 
Index: issm/trunk/src/c/classes/objects/Loads/Numericalflux.h
===================================================================
--- issm/trunk/src/c/classes/objects/Loads/Numericalflux.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Loads/Numericalflux.h	(revision 13975)
@@ -20,18 +20,16 @@
 
 	public: 
-		int         id;
+		int id;
 		int analysis_type;
 
 		/*Hooks*/
-		Hook*       helement;
-		Hook*       hnodes;
+		Hook *helement;
+		Hook *hnodes;
 
 		/*Corresponding fields*/
-		Element* element;
-		Node**   nodes;
-
-		Parameters *parameters;
-		Inputs     *inputs;
-
+		Element     *element;
+		Node       **nodes;
+		Parameters  *parameters;
+		Inputs      *inputs;
 
 		/*Numericalflux constructors,destructors {{{*/
@@ -44,5 +42,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
@@ -67,8 +64,12 @@
 		void  CreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* Kfs);
 		void  CreatePVector(Vector<IssmDouble>* pf);
+		void  GetNodesSidList(int* sidlist);
+		int   GetNumberOfNodes(void);
 		void  CreateJacobianMatrix(Matrix<IssmDouble>* Jff){_error_("Not implemented yet");};
+		bool  IsPenalty(void);
 		void  PenaltyCreateJacobianMatrix(Matrix<IssmDouble>* Jff,IssmDouble kmax){_error_("Not implemented yet");};
 		void  PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* kfs, IssmDouble kmax);
 		void  PenaltyCreatePVector(Vector<IssmDouble>* pf, IssmDouble kmax);
+		void  SetwiseNodeConnectivity(int* d_nz,int* o_nz,Node* node,bool* flags,int set1_enum,int set2_enum);
 		bool  InAnalysis(int analysis_type);
 		/*}}}*/
Index: issm/trunk/src/c/classes/objects/Loads/Pengrid.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Loads/Pengrid.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Loads/Pengrid.cpp	(revision 13975)
@@ -19,5 +19,5 @@
 #include "../../../Container/Container.h"
 /*}}}*/
-	
+
 /*Element macros*/
 #define NUMVERTICES   1
@@ -34,5 +34,5 @@
 	this->hmatpar=NULL;
 	this->matpar=NULL;
-	
+
 	/*not active, not zigzagging: */
 	active=0;
@@ -44,5 +44,4 @@
 Pengrid::Pengrid(int id, int index, IoModel* iomodel, int in_analysis_type){ //i is the element index
 
-	int i,j;
 	int pengrid_node_id;
 	int pengrid_matpar_id;
@@ -64,5 +63,5 @@
 	this->id=id;
 	this->analysis_type=in_analysis_type;
-	
+
 	/*hooks: */
 	pengrid_node_id=iomodel->nodecounter+index+1;
@@ -99,5 +98,5 @@
 }
 /*}}}*/
-			
+
 /*Object virtual functions definitions:*/
 /*FUNCTION Pengrid::Echo {{{*/
@@ -126,10 +125,4 @@
 int    Pengrid::Id(void){ return id; }
 /*}}}*/
-/*FUNCTION Pengrid::MyRank {{{*/
-int    Pengrid::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION Pengrid::ObjectEnum{{{*/
 int Pengrid::ObjectEnum(void){
@@ -140,5 +133,5 @@
 /*FUNCTION Icefront::copy {{{*/
 Object* Pengrid::copy() {
-	
+
 	Pengrid* pengrid=NULL;
 
@@ -214,4 +207,19 @@
 	return;
 
+}
+/*}}}*/
+/*FUNCTION Pengrid::GetNodesSidList{{{*/
+void Pengrid::GetNodesSidList(int* sidlist){
+
+	_assert_(sidlist);
+	_assert_(node);
+
+	sidlist[0]=node->Sid();
+}
+/*}}}*/
+/*FUNCTION Pengrid::GetNumberOfNodes{{{*/
+int Pengrid::GetNumberOfNodes(void){
+
+	return NUMVERTICES;
 }
 /*}}}*/
@@ -287,4 +295,56 @@
 }
 /*}}}*/
+/*FUNCTION Pengrid::IsPenalty{{{*/
+bool Pengrid::IsPenalty(void){
+	return true;
+}
+/*}}}*/
+/*FUNCTION Pengrid::SetwiseNodeConnectivity{{{*/
+void Pengrid::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int set1_enum,int set2_enum){
+
+	/*Output */
+	int d_nz = 0;
+	int o_nz = 0;
+
+	if(!flags[this->node->Sid()]){
+
+		/*flag current node so that no other element processes it*/
+		flags[this->node->Sid()]=true;
+
+		/*if node is clone, we have an off-diagonal non-zero, else it is a diagonal non-zero*/
+		switch(set2_enum){
+			case FsetEnum:
+				if(node->indexing.fsize){
+					if(this->node->IsClone())
+					 o_nz += 1;
+					else
+					 d_nz += 1;
+				}
+				break;
+			case GsetEnum:
+				if(node->indexing.gsize){
+					if(this->node->IsClone())
+					 o_nz += 1;
+					else
+					 d_nz += 1;
+				}
+				break;
+			case SsetEnum:
+				if(node->indexing.ssize){
+					if(this->node->IsClone())
+					 o_nz += 1;
+					else
+					 d_nz += 1;
+				}
+				break;
+			default: _error_("not supported");
+		}
+	}
+
+	/*Assign output pointers: */
+	*pd_nz=d_nz;
+	*po_nz=o_nz;
+}
+/*}}}*/
 
 /*Update virtual functions definitions:*/
@@ -401,5 +461,5 @@
 	/*recover pointers: */
 	Penta* penta=(Penta*)element;
-	
+
 	/*check that pengrid is not a clone (penalty to be added only once)*/
 	if (node->IsClone()){
@@ -415,5 +475,5 @@
 	//Recover our data:
 	parameters->FindParam(&penalty_lock,ThermalPenaltyLockEnum);
-	
+
 	//Compute pressure melting point
 	t_pmp=matpar->TMeltingPoint(pressure);
@@ -427,5 +487,4 @@
 		new_active=0;
 	}
-
 
 	//Figure out stability of this penalty
@@ -456,5 +515,5 @@
 /*FUNCTION Pengrid::PenaltyCreateKMatrixDiagnosticStokes {{{*/
 ElementMatrix* Pengrid::PenaltyCreateKMatrixDiagnosticStokes(IssmDouble kmax){
-	
+
 	const int numdof = NUMVERTICES *NDOF4;
 	IssmDouble    slope[2];
@@ -505,5 +564,5 @@
 	penta->GetInputValue(&temperature,node,TemperatureEnum);
 	parameters->FindParam(&penalty_factor,ThermalPenaltyFactorEnum);
-	
+
 	/*Compute pressure melting point*/
 	t_pmp=matpar->GetMeltingPoint()-matpar->GetBeta()*pressure;
@@ -539,5 +598,5 @@
 /*FUNCTION Pengrid::PenaltyCreatePVectorMelting {{{*/
 ElementVector* Pengrid::PenaltyCreatePVectorMelting(IssmDouble kmax){
-	
+
 	const int numdof=NUMVERTICES*NDOF1;
 	IssmDouble pressure;
Index: issm/trunk/src/c/classes/objects/Loads/Pengrid.h
===================================================================
--- issm/trunk/src/c/classes/objects/Loads/Pengrid.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Loads/Pengrid.h	(revision 13975)
@@ -20,5 +20,5 @@
 		int		id;
 		int analysis_type;
-		
+
 		/*Hooks*/
 		Hook* hnode;  //hook to 1 node
@@ -33,5 +33,5 @@
 		Parameters* parameters; //pointer to solution parameters
 		Inputs*  inputs;
-	
+
 		/*internals: */
 		int active;
@@ -49,5 +49,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
@@ -73,7 +72,11 @@
 		void  CreatePVector(Vector<IssmDouble>* pf);
 		void  CreateJacobianMatrix(Matrix<IssmDouble>* Jff){_error_("Not implemented yet");};
+		void  GetNodesSidList(int* sidlist);
+		int   GetNumberOfNodes(void);
+		bool  IsPenalty(void);
 		void  PenaltyCreateJacobianMatrix(Matrix<IssmDouble>* Jff,IssmDouble kmax){_error_("Not implemented yet");};
 		void  PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* kfs, IssmDouble kmax);
 		void  PenaltyCreatePVector(Vector<IssmDouble>* pf, IssmDouble kmax);
+		void  SetwiseNodeConnectivity(int* d_nz,int* o_nz,Node* node,bool* flags,int set1_enum,int set2_enum);
 		bool  InAnalysis(int analysis_type);
 		/*}}}*/
@@ -97,4 +100,2 @@
 
 #endif  /* _PENGRID_H_ */
-
-
Index: issm/trunk/src/c/classes/objects/Loads/Penpair.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Loads/Penpair.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Loads/Penpair.cpp	(revision 13975)
@@ -34,5 +34,5 @@
 /*FUNCTION Penpair::creation {{{*/
 Penpair::Penpair(int penpair_id, int* penpair_node_ids,int in_analysis_type){
-	
+
 	this->id=penpair_id;
 	this->analysis_type=in_analysis_type;
@@ -40,5 +40,5 @@
 	this->parameters=NULL;
 	this->nodes=NULL;
-	
+
 	return;
 }
@@ -54,6 +54,4 @@
 /*FUNCTION Penpair::Echo {{{*/
 void Penpair::Echo(void){
-
-	int i;
 
 	_printLine_("Penpair:");
@@ -61,5 +59,5 @@
 	_printLine_("   analysis_type: " << EnumToStringx(analysis_type));
 	hnodes->Echo();
-	
+
 	return;
 }
@@ -79,10 +77,4 @@
 int    Penpair::Id(void){ return id; }
 /*}}}*/
-/*FUNCTION Penpair::MyRank {{{*/
-int    Penpair::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION Penpair::ObjectEnum{{{*/
 int Penpair::ObjectEnum(void){
@@ -93,5 +85,5 @@
 /*FUNCTION Penpair::copy {{{*/
 Object* Penpair::copy() {
-	
+
 	Penpair* penpair=NULL;
 
@@ -113,5 +105,5 @@
 }
 /*}}}*/
-		
+
 /*Load virtual functions definitions:*/
 /*FUNCTION Penpair::Configure {{{*/
@@ -154,4 +146,24 @@
 void  Penpair::CreateJacobianMatrix(Matrix<IssmDouble>* Jff){
 	this->CreateKMatrix(Jff,NULL);
+}
+/*}}}*/
+/*FUNCTION Penpair::GetNodesSidList{{{*/
+void Penpair::GetNodesSidList(int* sidlist){
+
+	_assert_(sidlist);
+	_assert_(nodes);
+
+	for(int i=0;i<NUMVERTICES;i++) sidlist[i]=nodes[i]->Sid();
+}
+/*}}}*/
+/*FUNCTION Penpair::GetNumberOfNodes{{{*/
+int Penpair::GetNumberOfNodes(void){
+
+	return NUMVERTICES;
+}
+/*}}}*/
+/*FUNCTION Penpair::IsPenalty{{{*/
+bool Penpair::IsPenalty(void){
+	return true;
 }
 /*}}}*/
@@ -197,4 +209,55 @@
 	if (in_analysis_type==this->analysis_type)return true;
 	else return false;
+}
+/*}}}*/
+/*FUNCTION Penpair::SetwiseNodeConnectivity{{{*/
+void Penpair::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int set1_enum,int set2_enum){
+
+	/*Output */
+	int d_nz = 0;
+	int o_nz = 0;
+
+	/*Loop over all nodes*/
+	for(int i=0;i<NUMVERTICES;i++){
+
+		if(!flags[this->nodes[i]->Sid()]){
+
+			/*flag current node so that no other element processes it*/
+			flags[this->nodes[i]->Sid()]=true;
+
+			/*if node is clone, we have an off-diagonal non-zero, else it is a diagonal non-zero*/
+			switch(set2_enum){
+				case FsetEnum:
+					if(nodes[i]->indexing.fsize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				case GsetEnum:
+					if(nodes[i]->indexing.gsize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				case SsetEnum:
+					if(nodes[i]->indexing.ssize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				default: _error_("not supported");
+			}
+		}
+	}
+
+	/*Assign output pointers: */
+	*pd_nz=d_nz;
+	*po_nz=o_nz;
 }
 /*}}}*/
@@ -270,5 +333,5 @@
 /*FUNCTION Penpair::PenaltyCreateKMatrixDiagnosticMacAyealPattyn {{{*/
 ElementMatrix* Penpair::PenaltyCreateKMatrixDiagnosticMacAyealPattyn(IssmDouble kmax){
-	
+
 	const int numdof=NUMVERTICES*NDOF2;
 	IssmDouble penalty_offset;
@@ -297,5 +360,5 @@
 /*FUNCTION Penpair::PenaltyCreateKMatrixDiagnosticStokes {{{*/
 ElementMatrix* Penpair::PenaltyCreateKMatrixDiagnosticStokes(IssmDouble kmax){
-	
+
 	const int numdof=NUMVERTICES*NDOF4;
 	IssmDouble penalty_offset;
@@ -317,5 +380,5 @@
 	Ke->values[5*numdof+1]=-kmax*pow((IssmDouble)10.0,penalty_offset);
 	Ke->values[5*numdof+5]=+kmax*pow((IssmDouble)10.0,penalty_offset);
-	
+
 	Ke->values[2*numdof+2]=+kmax*pow((IssmDouble)10.0,penalty_offset);
 	Ke->values[2*numdof+6]=-kmax*pow((IssmDouble)10.0,penalty_offset);
Index: issm/trunk/src/c/classes/objects/Loads/Penpair.h
===================================================================
--- issm/trunk/src/c/classes/objects/Loads/Penpair.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Loads/Penpair.h	(revision 13975)
@@ -17,11 +17,9 @@
 
 	private: 
-		int		id;
-		int analysis_type;
-		
-		Hook* hnodes;  //hook to 2 nodes
-		Node** nodes;
-
-		Parameters* parameters; //pointer to solution parameters
+		int          id;
+		int          analysis_type;
+		Hook        *hnodes;          //hook to 2 nodes
+		Node       **nodes;
+		Parameters  *parameters;      //pointer to solution parameters
 
 	public:
@@ -36,5 +34,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
@@ -60,7 +57,11 @@
 		void  CreatePVector(Vector<IssmDouble>* pf);
 		void  CreateJacobianMatrix(Matrix<IssmDouble>* Jff);
+		void  GetNodesSidList(int* sidlist);
+		int   GetNumberOfNodes(void);
+		bool  IsPenalty(void);
 		void  PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff,Matrix<IssmDouble>* Kfs,IssmDouble kmax);
 		void  PenaltyCreatePVector(Vector<IssmDouble>* pf, IssmDouble kmax);
 		void  PenaltyCreateJacobianMatrix(Matrix<IssmDouble>* Jff,IssmDouble kmax);
+		void  SetwiseNodeConnectivity(int* d_nz,int* o_nz,Node* node,bool* flags,int set1_enum,int set2_enum);
 		bool  InAnalysis(int analysis_type);
 		/*}}}*/
@@ -74,4 +75,2 @@
 
 #endif  /* _PENPAIR_H_ */
-
-
Index: issm/trunk/src/c/classes/objects/Loads/Riftfront.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Loads/Riftfront.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Loads/Riftfront.cpp	(revision 13975)
@@ -97,5 +97,5 @@
 	//intialize inputs, and add as many inputs per element as requested: 
 	this->inputs=new Inputs();
-		
+
 	riftfront_type=SegmentRiftfrontEnum;
 	riftfront_fill = reCast<int,IssmDouble>(*(iomodel->Data(RiftsRiftstructEnum)+RIFTINFOSIZE*i+7));
@@ -109,5 +109,5 @@
 	this->inputs->AddInput(new DoubleInput(FractionIncrementEnum,riftfront_fractionincrement));
 	this->inputs->AddInput(new BoolInput(SegmentOnIceShelfEnum,riftfront_shelf));
-	
+
 	//parameters and hooked fields: we still can't point to them, they may not even exist. Configure will handle this.
 	this->parameters=NULL;
@@ -115,5 +115,5 @@
 	this->elements= NULL;
 	this->matpar= NULL;
-		
+
 }
 /*}}}*/
@@ -137,5 +137,4 @@
 	IssmDouble friction,fractionincrement;
 
-	
 	/*recover some inputs first: */
 	input=(Input*)this->inputs->GetInput(FillEnum); input->GetInputValue(&fill);
@@ -165,5 +164,5 @@
 	_printLine_("   state: " << state);
 	_printLine_("   frozen: " << (frozen ? "true":"false"));
-		
+
 }
 /*}}}*/
@@ -186,10 +185,4 @@
 int    Riftfront::Id(void){ return id; }
 /*}}}*/
-/*FUNCTION Riftfront::MyRank {{{*/
-int    Riftfront::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION Riftfront::ObjectEnum{{{*/
 int Riftfront::ObjectEnum(void){
@@ -201,5 +194,5 @@
 /*FUNCTION Riftfront::copy {{{*/
 Object* Riftfront::copy() {
-	
+
 	Riftfront* riftfront=NULL;
 
@@ -240,10 +233,10 @@
 	riftfront->length=this->length;
 	riftfront->fraction=this->fraction;
-	
+
 	return riftfront;
 
 }
 /*}}}*/
-		
+
 /*Update virtual functions definitions:*/
 /*FUNCTION Riftfront::InputUpdateFromConstant(bool constant,int name) {{{*/
@@ -281,5 +274,4 @@
 }
 /*}}}*/
-
 
 /*Load virtual functions definitions:*/
@@ -301,4 +293,9 @@
 	this->parameters=parametersin;
 
+}
+/*}}}*/
+/*FUNCTION Riftfront::IsPenalty{{{*/
+bool Riftfront::IsPenalty(void){
+	return true;
 }
 /*}}}*/
@@ -372,4 +369,19 @@
 }
 /*}}}*/
+/*FUNCTION Riftfront::GetNodesSidList{{{*/
+void Riftfront::GetNodesSidList(int* sidlist){
+
+	_assert_(sidlist);
+	_assert_(nodes);
+
+	for(int i=0;i<NUMVERTICES;i++) sidlist[i]=nodes[i]->Sid();
+}
+/*}}}*/
+/*FUNCTION Riftfront::GetNumberOfNodes{{{*/
+int Riftfront::GetNumberOfNodes(void){
+
+	return NUMVERTICES;
+}
+/*}}}*/
 /*FUNCTION Riftfront::InAnalysis{{{*/
 bool Riftfront::InAnalysis(int in_analysis_type){
@@ -378,4 +390,55 @@
 }
 /*}}}*/
+/*FUNCTION Riftfront::SetwiseNodeConnectivity{{{*/
+void Riftfront::SetwiseNodeConnectivity(int* pd_nz,int* po_nz,Node* node,bool* flags,int set1_enum,int set2_enum){
+
+	/*Output */
+	int d_nz = 0;
+	int o_nz = 0;
+
+	/*Loop over all nodes*/
+	for(int i=0;i<NUMVERTICES;i++){
+
+		if(!flags[this->nodes[i]->Sid()]){
+
+			/*flag current node so that no other element processes it*/
+			flags[this->nodes[i]->Sid()]=true;
+
+			/*if node is clone, we have an off-diagonal non-zero, else it is a diagonal non-zero*/
+			switch(set2_enum){
+				case FsetEnum:
+					if(nodes[i]->indexing.fsize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				case GsetEnum:
+					if(nodes[i]->indexing.gsize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				case SsetEnum:
+					if(nodes[i]->indexing.ssize){
+						if(this->nodes[i]->IsClone())
+						 o_nz += 1;
+						else
+						 d_nz += 1;
+					}
+					break;
+				default: _error_("not supported");
+			}
+		}
+	}
+
+	/*Assign output pointers: */
+	*pd_nz=d_nz;
+	*po_nz=o_nz;
+}
+/*}}}*/
 
 /*Riftfront numerics*/
@@ -384,11 +447,9 @@
 
 	const int   numdof = NDOF2*NUMVERTICES;
-	int         i,j;
 	int         dofs[1]             = {0};
-	IssmDouble      Ke_gg[4][4];
-	IssmDouble      thickness;
-	IssmDouble      h[2];
-	IssmDouble      penalty_offset;
-	IssmDouble      friction;
+	IssmDouble  thickness;
+	IssmDouble  h[2];
+	IssmDouble  penalty_offset;
+	IssmDouble  friction;
 
 	/*Objects: */
@@ -466,24 +527,24 @@
 ElementVector* Riftfront::PenaltyCreatePVectorDiagnosticHoriz(IssmDouble kmax){
 
-	const int   numdof = NDOF2*NUMVERTICES;
-	int         i,j;
-	IssmDouble      rho_ice;
-	IssmDouble      rho_water;
-	IssmDouble      gravity;
-	IssmDouble      thickness;
-	IssmDouble      h[2];
-	IssmDouble      bed;
-	IssmDouble      b[2];
-	IssmDouble      pressure;
-	IssmDouble      pressure_litho;
-	IssmDouble      pressure_air;
-	IssmDouble      pressure_melange;
-	IssmDouble      pressure_water;
-	int         fill;
-	bool        shelf;
+	const int  numdof = NDOF2*NUMVERTICES;
+	int        j;
+	IssmDouble rho_ice;
+	IssmDouble rho_water;
+	IssmDouble gravity;
+	IssmDouble thickness;
+	IssmDouble h[2];
+	IssmDouble bed;
+	IssmDouble b[2];
+	IssmDouble pressure;
+	IssmDouble pressure_litho;
+	IssmDouble pressure_air;
+	IssmDouble pressure_melange;
+	IssmDouble pressure_water;
+	int        fill;
+	bool       shelf;
 
 	/*Objects: */
-	Tria       *tria1               = NULL;
-	Tria       *tria2               = NULL;
+	Tria *tria1 = NULL;
+	Tria *tria2 = NULL;
 
 	/*enum of element? */
@@ -569,8 +630,6 @@
 
 	const int   numnodes        = 2;
-	IssmDouble      max_penetration;
 	IssmDouble      penetration;
 	int         activate;
-	int         found;
 	int         unstable;
 	IssmDouble      vx1;
@@ -602,10 +661,9 @@
 		if(this->state==OpenEnum)this->active=0;
 		if(this->state==ClosedEnum)this->active=1;
-		
+
 		/*this segment is like frozen, no instability here: */
 		*punstable=0;
 		return 1;
 	}
-
 
 	/*recover parameters: */
@@ -674,5 +732,4 @@
 int   Riftfront::IsMaterialStable(void){
 
-	int found=0;
 	IssmDouble converged=0;
 
@@ -693,7 +750,5 @@
 
 	const int     numnodes=2;
-	IssmDouble        max_penetration;
 	IssmDouble        penetration=0;
-	int           found;
 	IssmDouble      vx1;
 	IssmDouble      vy1;
@@ -729,5 +784,5 @@
 	/*If we are zigzag locked, same thing: */
 	if(this->counter>this->penalty_lock)penetration=-1;
-	
+
 	/*assign output pointer: */
 	*ppenetration=penetration;
@@ -744,5 +799,4 @@
 
 	IssmDouble    penetration;
-	int       found;
 
 	/*Objects: */
@@ -768,5 +822,5 @@
 	/*Now, we return penetration only if we are active!: */
 	if(this->active==0)penetration=0;
-	
+
 	/*assign output pointer: */
 	*ppenetration=penetration;
@@ -777,19 +831,15 @@
 int   Riftfront::PotentialUnstableConstraint(int* punstable){
 
-
 	const int   numnodes        = 2;
-	IssmDouble      max_penetration;
-	IssmDouble      penetration;
-	int         activate;
+	IssmDouble  penetration;
 	int         unstable;
-	int         found;
-	IssmDouble      vx1;
-	IssmDouble      vy1;
-	IssmDouble      vx2;
-	IssmDouble      vy2;
+	IssmDouble  vx1;
+	IssmDouble  vy1;
+	IssmDouble  vx2;
+	IssmDouble  vy2;
 
 	/*Objects: */
-	Tria       *tria1           = NULL;
-	Tria       *tria2           = NULL;
+	Tria       *tria1 = NULL;
+	Tria       *tria2 = NULL;
 
 	/*enum of element? */
@@ -833,5 +883,4 @@
 	IssmDouble      penetration;
 	int         unstable;
-	int         found;
 	IssmDouble      vx1;
 	IssmDouble      vy1;
Index: issm/trunk/src/c/classes/objects/Loads/Riftfront.h
===================================================================
--- issm/trunk/src/c/classes/objects/Loads/Riftfront.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Loads/Riftfront.h	(revision 13975)
@@ -25,5 +25,5 @@
 		Hook* helements;
 		Hook* hmatpar;
-		
+
 		/*Corresponding fields*/
 		Matpar   *matpar;
@@ -32,18 +32,17 @@
 
 		/*computational: */
-		int      penalty_lock;
-		bool     active;
-		bool     frozen;
-		int      counter;
-		bool     prestable;
-		bool     material_converged;
-		IssmDouble   normal[2];
-		IssmDouble   length;
-		IssmDouble   fraction;
-		int      state;
-		
-		Parameters* parameters; //pointer to solution parameters
-		Inputs*  inputs;
+		int         penalty_lock;
+		bool        active;
+		bool        frozen;
+		int         counter;
+		bool        prestable;
+		bool        material_converged;
+		IssmDouble  normal[2];
+		IssmDouble  length;
+		IssmDouble  fraction;
+		int         state;
 
+		Parameters *parameters;           //pointer to solution parameters
+		Inputs     *inputs;
 
 		/*Riftfrontconstructors,destructors: {{{*/
@@ -56,5 +55,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
@@ -80,7 +78,11 @@
 		void  CreatePVector(Vector<IssmDouble>* pf);
 		void  CreateJacobianMatrix(Matrix<IssmDouble>* Jff){_error_("Not implemented yet");};
+		void  GetNodesSidList(int* sidlist);
+		int   GetNumberOfNodes(void);
+		bool  IsPenalty(void);
 		void  PenaltyCreateJacobianMatrix(Matrix<IssmDouble>* Jff,IssmDouble kmax){_error_("Not implemented yet");};
 		void  PenaltyCreateKMatrix(Matrix<IssmDouble>* Kff, Matrix<IssmDouble>* kfs, IssmDouble kmax);
 		void  PenaltyCreatePVector(Vector<IssmDouble>* pf, IssmDouble kmax);
+		void  SetwiseNodeConnectivity(int* d_nz,int* o_nz,Node* node,bool* flags,int set1_enum,int set2_enum);
 		bool  InAnalysis(int analysis_type);
 		/*}}}*/
Index: issm/trunk/src/c/classes/objects/Materials/Matdamageice.cpp
===================================================================
--- issm/trunk/src/c/classes/objects/Materials/Matdamageice.cpp	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Materials/Matdamageice.cpp	(revision 13975)
@@ -15,5 +15,5 @@
 #include "../../../shared/shared.h"
 #include "../../../include/include.h"
-		
+
 /*Matdamageice constructors and destructor*/
 /*FUNCTION Matdamageice::Matdamageice(){{{*/
@@ -28,5 +28,4 @@
 
 	/*Intermediaries:*/
-	int    i;
 	int    matice_eid;
 
@@ -82,10 +81,4 @@
 int    Matdamageice::Id(void){ return mid; }
 /*}}}*/
-/*FUNCTION Matdamageice::MyRank {{{*/
-int    Matdamageice::MyRank(void){ 
-	extern int my_rank;
-	return my_rank; 
-}
-/*}}}*/
 /*FUNCTION Matdamageice::ObjectEnum{{{*/
 int Matdamageice::ObjectEnum(void){
@@ -210,5 +203,5 @@
 			/*Prepare index list*/
 			int doflist1[3];
-			for(int i=0;i<3;i++) doflist1[i]=((Tria*)element)->nodes[i]->GetVertexDof();
+			for(int i=0;i<3;i++) doflist1[i]=((Tria*)element)->nodes[i]->GetVertexPid();
 
 			/*Get input (either in element or material)*/
@@ -305,5 +298,5 @@
 	 * return g, initial viscosity.
 	 */
-	
+
 	/*output: */
 	IssmDouble viscosity3d;
@@ -347,5 +340,5 @@
 			else{
 				e=(n-1)/2/n;
-			
+
 				viscosity3d=B/(2*pow(A,e));
 			}
@@ -376,5 +369,5 @@
 	 * return g, initial viscosity.
 	 */
-	
+
 	/*output: */
 	IssmDouble viscosity3d;
@@ -393,5 +386,5 @@
 	Z=GetZ();
 	B=Z*GetB();
-	
+
 	if (n==1){
 		/*Viscous behaviour! viscosity3d=B: */
@@ -446,5 +439,5 @@
 	 * return mu20, initial viscosity.
 	 */
-	
+
 	/*output: */
 	IssmDouble viscosity_complement;
@@ -474,5 +467,5 @@
 		else{
 			e=(n-1)/(2*n);
-		
+
 			viscosity_complement=1/(2*pow(A,e));
 		}
@@ -486,5 +479,5 @@
 	_assert_(n>0);
 	_assert_(viscosity_complement>0);
-		
+
 	/*Return: */
 	*pviscosity_complement=viscosity_complement;
@@ -502,5 +495,5 @@
 	 * return mu20, initial viscosity.
 	 */
-	
+
 	/*output: */
 	IssmDouble viscosity_complement;
@@ -530,5 +523,5 @@
 		else{
 			e=(n-1)/(2*n);
-		
+
 			viscosity_complement=B/(2*pow(A,e));
 		}
@@ -542,5 +535,5 @@
 	_assert_(n>0);
 	_assert_(viscosity_complement>0);
-		
+
 	/*Return: */
 	*pviscosity_complement=viscosity_complement;
@@ -589,5 +582,5 @@
 
 	/*input strain rate: */
-	IssmDouble exx,eyy,exy,exz;
+	IssmDouble exx,eyy,exy;
 
 	/*Get visocisty and n*/
@@ -640,5 +633,5 @@
 				case TriaEnum: {
 					IssmDouble values[3];
-					for (int i=0;i<3;i++) values[i]=vector[((Tria*)element)->nodes[i]->GetVertexDof()];
+					for (int i=0;i<3;i++) values[i]=vector[((Tria*)element)->nodes[i]->GetVertexPid()];
 					this->inputs->AddInput(new TriaP1Input(name,values));
 					return;
@@ -682,5 +675,5 @@
 				case TriaEnum: {
 					IssmDouble values[3];
-					for (int i=0;i<3;i++) values[i]=vector[((Tria*)element)->nodes[i]->GetSidList()]; //use sid list, to index into serial oriented vector 
+					for (int i=0;i<3;i++) values[i]=vector[((Tria*)element)->nodes[i]->GetVertexSid()]; //use sid list, to index into serial oriented vector 
 					this->inputs->AddInput(new TriaP1Input(name,values));
 					/*Special case for rheology B in 2D: Pourave land for this solution{{{*/
@@ -706,6 +699,4 @@
 		default: _error_("type " << type << " (" << EnumToStringx(type) << ") not implemented yet");
 	}
-
-
 
 }
Index: issm/trunk/src/c/classes/objects/Materials/Matdamageice.h
===================================================================
--- issm/trunk/src/c/classes/objects/Materials/Matdamageice.h	(revision 13405)
+++ issm/trunk/src/c/classes/objects/Materials/Matdamageice.h	(revision 13975)
@@ -28,5 +28,4 @@
 		void  DeepEcho();
 		int   Id(); 
-		int   MyRank();
 		int   ObjectEnum();
 		Object* copy();
